"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.RuleCore = void 0;
var core_types_1 = require("./core.types");
var RuleCore = /** @class */ (function () {
    function RuleCore() {
        var _this = this;
        /**
         * @param {Rules} rules - Map of Rules.
         * @returns {void}
         * @description to extend JsonLang by a Map() of rules the "Map key" is RuleIdentifier and the "Map value" is the Sync/Async RuleHandler
        */
        this.registerMany = function (rules, group) {
            rules.forEach(function (value, key) { return _this.registerOne(__assign({ group: group }, key), value); });
        };
        /**
         * @param {RuleIdentifier} ruleIdentifier
         * @param {RuleHandler} RuleHandler.
         * @returns {void}
         * @description to extend JsonLang by adding one Sync/Async Rule
        */
        this.registerOne = function (ruleIdentifier, ruleHandler) {
            _this.rules.set(ruleIdentifier.name, ruleHandler);
            _this.ruleIds.add(ruleIdentifier);
            if (ruleIdentifier.shortcut)
                _this.rules.set(ruleIdentifier.shortcut, ruleHandler);
        };
        /**
         * @returns {RuleIdentifier[]}
         * @description Get rules identifiers
        */
        this.getRulesIds = function () { return __spreadArray([], __read(_this.ruleIds), false); };
        this.createRunContext = function (outputs, data) {
            var run = function (scopedData) {
                var localData = scopedData;
                var innerRun = function (jsonLang) {
                    if (!_this.isRule(jsonLang))
                        return jsonLang;
                    var _a = _this.getRuleParams(jsonLang), ruleHandler = _a.ruleHandler, rule = _a.rule, _b = _a.inputs, inputs = _b === void 0 ? [] : _b, output = _a.output;
                    var resolvedInputs = _this.resolveRuleInputs(inputs, ruleHandler, innerRun, run);
                    resolvedInputs = _this.getAllInputs(rule, resolvedInputs, outputs, data, localData);
                    var result = ruleHandler.apply(void 0, __spreadArray([], __read(resolvedInputs), false));
                    if (output)
                        _this.setOutputValue(output, result, outputs);
                    return result;
                };
                return innerRun;
            };
            return run;
        };
        this.createAsyncRunContext = function (outputs, syncRun, data) {
            var run = function (scopedData) {
                var localData = scopedData;
                var innerRun = function (jsonLang) { return __awaiter(_this, void 0, void 0, function () {
                    var _a, ruleHandler, rule, _b, inputs, output, resolvedInputs, result, error_1;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                if (!this.isRule(jsonLang))
                                    return [2 /*return*/, jsonLang];
                                _a = this.getRuleParams(jsonLang), ruleHandler = _a.ruleHandler, rule = _a.rule, _b = _a.inputs, inputs = _b === void 0 ? [] : _b, output = _a.output;
                                _c.label = 1;
                            case 1:
                                _c.trys.push([1, 4, , 5]);
                                return [4 /*yield*/, this.resolveRuleAsyncInputs(inputs, ruleHandler, innerRun, syncRun, run)];
                            case 2:
                                resolvedInputs = _c.sent();
                                resolvedInputs = this.getAllInputs(rule, resolvedInputs, outputs, data, localData);
                                return [4 /*yield*/, ruleHandler.apply(void 0, __spreadArray([], __read(resolvedInputs), false))];
                            case 3:
                                result = _c.sent();
                                if (output)
                                    this.setOutputValue(output, result, outputs);
                                return [2 /*return*/, result];
                            case 4:
                                error_1 = _c.sent();
                                throw Error("Failed to Run \"".concat(rule, "\" cause of ").concat(error_1));
                            case 5: return [2 /*return*/];
                        }
                    });
                }); };
                return innerRun;
            };
            return run;
        };
        this.resolveRuleInputs = function (inputs, ruleHandler, run, runner) {
            var innerRules = _this.getHandlerInnerRules(ruleHandler);
            var resolvedInputs = inputs.map(function (input, i) {
                return _this.isRule(input) && !innerRules.rules.includes(i) ? run(input) : input;
            });
            if (innerRules.runner)
                resolvedInputs.splice(innerRules.runner, 0, runner);
            return resolvedInputs;
        };
        this.resolveRuleAsyncInputs = function (inputs, ruleHandler, run, runner, asyncRunner) { return __awaiter(_this, void 0, void 0, function () {
            var innerRules, resolvedInputs, i, input, result, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        innerRules = this.getHandlerInnerRules(ruleHandler);
                        resolvedInputs = [];
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < inputs.length)) return [3 /*break*/, 6];
                        input = inputs[i];
                        if (!(this.isRule(input) && !innerRules.rules.includes(i))) return [3 /*break*/, 3];
                        return [4 /*yield*/, run(input)];
                    case 2:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        _a = input;
                        _b.label = 4;
                    case 4:
                        result = _a;
                        resolvedInputs.push(result);
                        _b.label = 5;
                    case 5:
                        i++;
                        return [3 /*break*/, 1];
                    case 6:
                        if (innerRules.runner)
                            resolvedInputs.splice(innerRules.runner, 0, runner);
                        if (innerRules.asyncRunner)
                            resolvedInputs.splice(innerRules.asyncRunner, 0, asyncRunner);
                        return [2 /*return*/, resolvedInputs];
                }
            });
        }); };
        this.getHandlerInnerRules = function (ruleHandler) {
            var innerRules = { runner: null, asyncRunner: null, rules: [] };
            _this.getHandlerArgs(ruleHandler).forEach(function (arg, i) {
                if (arg === '$runner') {
                    innerRules.runner = i;
                }
                else if (arg === '$asyncRunner') {
                    innerRules.asyncRunner = i;
                }
                else if (arg.startsWith('$rule')) {
                    innerRules.rules.push(i);
                }
            });
            return innerRules;
        };
        this.getHandlerArgs = function (ruleHandler) {
            var _a, _b, _c, _d;
            return ((_d = (_c = (_b = (_a = ruleHandler
                .toString()) === null || _a === void 0 ? void 0 : _a.match(/\((.*?)\)/)) === null || _b === void 0 ? void 0 : _b[1]) === null || _c === void 0 ? void 0 : _c.split(',')) === null || _d === void 0 ? void 0 : _d.map(function (i) { return i.trim(); })) || [];
        };
        this.isRule = function (data) { return (data && typeof data === 'object' && data[core_types_1.RuleParams.Rule]); };
        this.setOutputValue = function (out, value, outputs) {
            outputs.set(out, value);
        };
        this.getOutputValue = function (varName, outputs) {
            var outputValue = outputs.get(varName);
            if (!outputValue)
                throw Error("The \"".concat(varName, "\" output value is not exist"));
            return outputValue;
        };
        this.getDate = function (data) {
            if (!data)
                throw Error('There is no data passed');
            return data;
        };
        this.rules = new Map();
        this.ruleIds = new Set();
        this.registerOne({ name: core_types_1.CoreRules.Var, group: 'Core' }, this.getOutputValue);
        this.registerOne({ name: core_types_1.CoreRules.Data, group: 'Core' }, this.getDate);
    }
    /**
     * @param {IJsonLangParams} jsonLang
     * @param {Object} data.
     * @returns {RuleResult}
     * @description is the `Sync` version of jsonLang, use it to run all builtin rules and any extended `Sync` Rules
    */
    RuleCore.prototype.execute = function (rules, data) {
        var outputs = new Map();
        var run = this.createRunContext(outputs, data);
        return run()(rules);
    };
    /**
     * @param {IJsonLangParams} jsonLang
     * @param {Object} data.
     * @returns {Promise<RuleResult>}
     * @description is the `Async` version of jsonLang, use it to run all builtin rules and any extended `Sync/Async` Rules
    */
    RuleCore.prototype.executeAsync = function (rules, data) {
        var outputs = new Map();
        var syncRun = this.createRunContext(outputs, data);
        var run = this.createAsyncRunContext(outputs, syncRun, data);
        return run()(rules);
    };
    RuleCore.prototype.getAllInputs = function (rule, inputs, outputs, data, scopedData) {
        var params = inputs;
        if (rule === core_types_1.CoreRules.Var) {
            params = [inputs === null || inputs === void 0 ? void 0 : inputs[0], outputs];
        }
        else if (rule === core_types_1.CoreRules.Data) {
            params = (inputs === null || inputs === void 0 ? void 0 : inputs[0]) === 'Local' ? [scopedData] : [data];
        }
        return params;
    };
    RuleCore.prototype.getRuleParams = function (jsonLang) {
        var rule = jsonLang[core_types_1.RuleParams.Rule];
        var inputs = jsonLang[core_types_1.RuleParams.Input];
        var output = jsonLang[core_types_1.RuleParams.Output];
        if (!Array.isArray(inputs))
            throw new Error('Invalid Rule, $I must be an array');
        var ruleHandler = this.rules.get(rule);
        if (!ruleHandler)
            throw Error("The \"".concat(rule, "\" Rule is not exist"));
        return { ruleHandler: ruleHandler, rule: rule, inputs: inputs, output: output };
    };
    return RuleCore;
}());
exports.RuleCore = RuleCore;
//# sourceMappingURL=core.js.map