"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.ArrayRules = void 0;
var ArrayRules = /** @class */ (function () {
    function ArrayRules() {
        var _this = this;
        this.register = function () {
            _this.rules.set({ name: 'All', group: 'Array/Collections' }, _this.all);
            _this.rules.set({ name: 'Map', group: 'Array/Collections' }, _this.map);
            _this.rules.set({ name: 'Filter', group: 'Array/Collections' }, _this.filter);
            _this.rules.set({ name: 'Flatten', group: 'Array/Collections' }, _this.flatten);
            _this.rules.set({ name: 'Foreach', group: 'Array/Collections' }, _this.foreach);
        };
        this.all = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).map(function (input) { return input; });
        };
        this.filter = function (elements, $rule, $runner) {
            return Array.isArray(elements) ? elements.filter(function (ele) { return $runner(ele)($rule); }) : [];
        };
        this.foreach = function (elements, $rule, $runner) {
            if (!Array.isArray(elements))
                return false;
            elements.forEach(function (ele) { return $runner(ele)($rule); });
            return true;
        };
        this.map = function (elements, $rule, $runner) {
            return Array.isArray(elements) ? elements.map(function (ele) { return $runner(ele)($rule); }) : [];
        };
        this.flatten = function (elements, lvl) {
            return Array.isArray(elements) ? elements.flat(lvl) : [];
        };
        this.rules = new Map();
        this.register();
    }
    ArrayRules.prototype.getRules = function () {
        return this.rules;
    };
    return ArrayRules;
}());
exports.ArrayRules = ArrayRules;
//# sourceMappingURL=array.js.map