"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.LogicalRules = void 0;
var LogicalRules = /** @class */ (function () {
    function LogicalRules() {
        var _this = this;
        this.register = function () {
            _this.rules.set({ name: 'And', shortcut: '&&', group: 'Logical' }, _this.and);
            _this.rules.set({ name: 'Or', shortcut: '||', group: 'Logical' }, _this.or);
            _this.rules.set({ name: 'Equal', shortcut: '==', group: 'Logical' }, _this.equal);
            _this.rules.set({ name: 'NotEqual', shortcut: '!=', group: 'Logical' }, _this.notEqual);
            _this.rules.set({ name: 'Not', shortcut: '!', group: 'Logical' }, _this.not);
            _this.rules.set({ name: 'GreaterThan', shortcut: '>', group: 'Logical' }, _this.greaterThan);
            _this.rules.set({ name: 'LessThan', shortcut: '<', group: 'Logical' }, _this.lessThan);
            _this.rules.set({ name: 'GreaterThanOrEqual', shortcut: '>=', group: 'Logical' }, _this.greaterThanOrEqual);
            _this.rules.set({ name: 'LessThanOrEqual', shortcut: '<=', group: 'Logical' }, _this.lessThanOrEqual);
            _this.rules.set({ name: 'If', group: 'Logical' }, _this["if"]);
        };
        this.areSameType = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).slice(1).every(function (i) { return typeof i === typeof inputs[0]; });
        };
        this.hasObjects = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).some(function (i) { return typeof i === 'object'; });
        };
        this.castToString = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).map(function (i) { return typeof i === 'string' ? i : JSON.stringify(i); });
        };
        this.jsonParse = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).map(function (i) {
                if (typeof i === 'string') {
                    try {
                        var result = JSON.parse(i);
                        return result;
                    }
                    catch (_a) {
                        return undefined;
                    }
                }
                else {
                    return i;
                }
            });
        };
        this.and = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).every(function (input) { return input; });
        };
        this.or = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            return __spreadArray([], __read(inputs), false).some(function (input) { return input; });
        };
        this.equal = function (lhs, rhs) {
            if (!_this.areSameType(lhs, rhs) || _this.hasObjects(lhs, rhs)) {
                var _a = __read(_this.castToString(lhs, rhs), 2), stringLHS = _a[0], stringRHS = _a[1];
                return stringLHS === stringRHS;
            }
            else {
                return lhs === rhs;
            }
        };
        this.notEqual = function (lhs, rhs) {
            if (!_this.areSameType(lhs, rhs) || _this.hasObjects(lhs, rhs)) {
                var _a = __read(_this.castToString(lhs, rhs), 2), stringLHS = _a[0], stringRHS = _a[1];
                return stringLHS !== stringRHS;
            }
            else {
                return lhs !== rhs;
            }
        };
        this.not = function (value) {
            return !value;
        };
        this.greaterThan = function (lhs, rhs) {
            if (_this.hasObjects(lhs, rhs))
                return false;
            var _a = __read(_this.jsonParse(lhs, rhs), 2), parsedLHS = _a[0], parsedRHS = _a[1];
            return _this.areSameType(parsedLHS, parsedRHS) ? parsedLHS > parsedRHS : false;
        };
        this.lessThan = function (lhs, rhs) {
            if (_this.hasObjects(lhs, rhs))
                return false;
            var _a = __read(_this.jsonParse(lhs, rhs), 2), parsedLHS = _a[0], parsedRHS = _a[1];
            return _this.areSameType(parsedLHS, parsedRHS) ? parsedLHS < parsedRHS : false;
        };
        this.greaterThanOrEqual = function (lhs, rhs) {
            if (_this.hasObjects(lhs, rhs))
                return false;
            var _a = __read(_this.jsonParse(lhs, rhs), 2), parsedLHS = _a[0], parsedRHS = _a[1];
            return _this.areSameType(parsedLHS, parsedRHS) ? parsedLHS >= parsedRHS : false;
        };
        this.lessThanOrEqual = function (lhs, rhs) {
            if (_this.hasObjects(lhs, rhs))
                return false;
            var _a = __read(_this.jsonParse(lhs, rhs), 2), parsedLHS = _a[0], parsedRHS = _a[1];
            return _this.areSameType(parsedLHS, parsedRHS) ? parsedLHS <= parsedRHS : false;
        };
        this["if"] = function ($rule_condition, $rule_then, $rule_else, $runner) {
            if (!$runner)
                return false;
            return $runner()($rule_condition) ? $runner()($rule_then) : $runner()($rule_else);
        };
        this.rules = new Map();
        this.register();
    }
    LogicalRules.prototype.getRules = function () {
        return this.rules;
    };
    return LogicalRules;
}());
exports.LogicalRules = LogicalRules;
//# sourceMappingURL=logical.js.map