"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.MathRules = void 0;
var MathRules = /** @class */ (function () {
    function MathRules() {
        var _this = this;
        this.register = function () {
            _this.rules.set({ name: 'IsNumber', group: 'Math' }, _this.isNumber);
            _this.rules.set({ name: 'Sum', shortcut: '+', group: 'Math' }, _this.sum);
            _this.rules.set({ name: 'Subtract', shortcut: '-', group: 'Math' }, _this.subtract);
            _this.rules.set({ name: 'Multiply', shortcut: '*', group: 'Math' }, _this.multiply);
            _this.rules.set({ name: 'Divide', shortcut: '/', group: 'Math' }, _this.divide);
            _this.rules.set({ name: 'Min', group: 'Math' }, _this.min);
            _this.rules.set({ name: 'Max', group: 'Math' }, _this.max);
        };
        this.isNumber = function (inputs) {
            return inputs.every(function (i) { return typeof i === 'number'; });
        };
        this.hasNoZero = function (inputs) {
            return inputs.every(function (i) { return i !== 0; });
        };
        this.sum = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) ? arrayOfInputs.reduce(function (a, b) { return a + b; }) : 0;
        };
        this.subtract = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) ? arrayOfInputs.reduce(function (a, b) { return a - b; }) : 0;
        };
        this.multiply = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) ? arrayOfInputs.reduce(function (a, b) { return a * b; }) : 0;
        };
        this.divide = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) && _this.hasNoZero(arrayOfInputs.slice(1)) ? arrayOfInputs.reduce(function (a, b) { return a / b; }) : 0;
        };
        this.min = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) ? Math.min.apply(Math, __spreadArray([], __read(inputs), false)) : null;
        };
        this.max = function () {
            var inputs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                inputs[_i] = arguments[_i];
            }
            var arrayOfInputs = __spreadArray([], __read(inputs), false);
            return _this.isNumber(arrayOfInputs) ? Math.max.apply(Math, __spreadArray([], __read(inputs), false)) : null;
        };
        this.rules = new Map();
        this.register();
    }
    MathRules.prototype.getRules = function () {
        return this.rules;
    };
    return MathRules;
}());
exports.MathRules = MathRules;
//# sourceMappingURL=math.js.map